%==== Multi-sensor 1 target Bayesian filtering:
% run this routine after you call 'declare_problem_single' and signal generation
% modification:
% 1. put index on it
% 2. put 'adaptive' P_D
% 3. make it fast
% 4. modify the birth process

P_D2_poor_res= 0.75;
P_D2_ok_res= 0.75;
tdoa_res= 5*dR;
model.r_b= 0;


%---
hat_N= zeros(K,1);      %(soft) estimate of the number of targets
particle_X= cell(K,1);  %cell for storing all particles
particle_X_idx= cell(K,1);
particle_W= cell(K,1);  %cell for storing the update weights
X1k= zeros(x_dim,Ns); active_1k= zeros(Ns,1); id_1k= zeros(Ns,1);
X2k= zeros(x_dim,Ns); active_2k= zeros(Ns,1); id_2k= zeros(Ns,1);
Wk= ones(Ns,1)/Ns;

for k=1:K
    %k
    time_start= cputime;
    X1k_old= X1k; X2k_old= X2k; id_1k_old= id_1k; id_2k_old= id_2k;
    idx1= find(active_1k~=0); idx2= find(active_2k~=0);
    idx1_empty= setdiff( (1:Ns), idx1 ); idx2_empty= setdiff( (1:Ns), idx2 );
    
    % target survival/death
    rv= rand(length(idx1),1);
    j_idx= find(rv>P_death);
    active_1k= zeros(Ns,1); active_1k(idx1(j_idx))= 1;
    X1k= zeros(x_dim,Ns); id_1k= zeros(Ns,1);
    if ~isempty(j_idx),
        X1k(:,idx1(j_idx))= gen_newstate(model,X1k_old(:,idx1(j_idx)));
        id_1k(idx1(j_idx))= id_1k_old(idx1(j_idx));
    end;
    
    rv= rand(length(idx2),1);
    j_idx= find(rv>P_death);
    active_2k= zeros(Ns,1); active_2k(idx2(j_idx))= 1;
    X2k= zeros(x_dim,Ns); id_2k= zeros(Ns,1);
    if ~isempty(j_idx),
        X2k(:,idx2(j_idx))= gen_newstate(model,X2k_old(:,idx2(j_idx)));
        id_2k(idx2(j_idx))= id_2k_old(idx2(j_idx));
    end;
    
    % now birth
    idx1n2_empty= intersect(idx1_empty,idx2_empty);
    if ~isempty(idx1n2_empty),
        rv= rand(length(idx1n2_empty),1);
        j_idx= find(rv<=P_birth);
        X1k(:,idx1n2_empty(j_idx))= gen_birthstate(model,length(j_idx));
        id_1k(idx1n2_empty(j_idx))= k;
        active_1k(idx1n2_empty(j_idx))= 1;
    end;
    idx1_empty= setdiff(idx1_empty,idx1n2_empty);
    idx2_empty= setdiff(idx2_empty,idx1n2_empty);
    rv= rand(length(idx1_empty),1);
    j_idx= find(rv<=P_birth);
    X1k(:,idx1_empty(j_idx))= gen_birthstate_cond(model,X2k_old(:,idx1_empty(j_idx)));
    id_1k(idx1_empty(j_idx))= k;
    active_1k(idx1_empty(j_idx))= 1;
    rv= rand(length(idx2_empty),1);
    j_idx= find(rv<=P_birth);
    X2k(:,idx2_empty(j_idx))= gen_birthstate_cond(model,X1k_old(:,idx2_empty(j_idx)));
    id_2k(idx2_empty(j_idx))= k;   
    active_2k(idx2_empty(j_idx))= 1;
    
    
    %weight update: Nk=1
    Nk= active_1k+active_2k;
    idx_N1= find(Nk==1);
    if ~isempty(idx_N1),
        Xk_temp= X1k(:,idx_N1)+ X2k(:,idx_N1);
        for q=1:Q
            Zk_len= size(Z{q,k},2);
            f_zx= zeros(1,length(idx_N1));
            for i=1:Zk_len
                f_zx= f_zx+ compute_likelihood(model,Z{q,k}(:,i),Xk_temp,q);
            end;
            Wk(idx_N1)= Wk(idx_N1).* ...
                ( (1-P_D) + P_D*f_zx'/(lambda_c/prod(range_c(:,2)-range_c(:,1))) );
        end;
    end;
    %weight update: Nk=2
    P_D2= P_D;
    idx_N2= find(Nk==2);
    if ~isempty(idx_N2),
        for q=1:Q
            fzx1= zeros(1,length(idx_N2)); fzx2=zeros(1,length(idx_N2)); 
            fzx12= zeros(1,length(idx_N2));
            for i=1:size(Z{q,k},2)
                t1= compute_likelihood(model,Z{q,k}(:,i),X1k(:,idx_N2),q);
                t2= compute_likelihood(model,Z{q,k}(:,i),X2k(:,idx_N2),q);
                fzx1= fzx1+ t1;
                fzx2= fzx2+ t2;
                fzx12= fzx12+ t1.*t2;
            end;
            Wk(idx_N2)= Wk(idx_N2).*( ...
                ( (1-P_D2)+ P_D2*fzx1/(lambda_c/prod(range_c(:,2)-range_c(:,1))) ).* ...
                ( (1-P_D2)+ P_D2*fzx2/(lambda_c/prod(range_c(:,2)-range_c(:,1))) ) - ...
                fzx12*(P_D2/(lambda_c/prod(range_c(:,2)-range_c(:,1))))^2 )';
        end;
    end;
    
    % weight normalization and resampling
    Wk= Wk/sum(Wk);
    idx= resample(Wk,Ns);
    Wk= ones(Ns,1)/Ns;
    X1k= X1k(:,idx); X2k= X2k(:,idx);
    id_1k= id_1k(idx); id_2k= id_2k(idx);
    active_1k= active_1k(idx); active_2k= active_2k(idx);
    
    %store particles and weights
    idx1= find(active_1k~=0); idx2= find(active_2k~=0);
    particle_X{k}= [ X1k(:,idx1) X2k(:,idx2) ];
    particle_X_idx{k}= [ id_1k(idx1); id_2k(idx2) ];
    particle_W{k}= Wk;
    hat_N(k)= size(particle_X{k},2)/Ns;
    
end;


        
