% use after 'phdfilter'
% find the state vector estimate by using K-mean clustering

hat_X= cell(K,1);
for k=1:K
    hat_N(k)= size(particle_X{k},2)/Ns;
    Nt= round(hat_N(k));
    if Nt==1, %no clustering need for hat_N= 1
        hat_X{k}= (sum(particle_X{k}')')/size(particle_X{k},2);
    elseif Nt > 1 & k > 1,
        if round(hat_N(k-1))== Nt,
            [idx,cluster_pts]= kmeans(particle_X{k}',Nt,...
                'maxiter',100,'emptyaction','singleton','start',hat_X{k-1}');
        else
            [idx,cluster_pts]= kmeans(particle_X{k}',Nt,...
                'maxiter',100,'replicates',50,'emptyaction','singleton');
        end;
        hat_X{k}= cluster_pts';
    end;
    disp(['Time step= ',num2str(k)]);
end;

