%--- coordinate plot with respect to time
% you need to define model.C_posn in order to work properly

[X_track,k_birth,k_death]= extract_tracks(X,track_list,total_tracks);
N_true= zeros(K,1);
for k=1:K
    N_true(k)= size(X{k},2);
end;


figure(1); clf; subplot(211);
figure(2); clf; subplot(211);
figure(3); clf;

%--- plot true tracks
for i=1:total_tracks
    P= model.C_posn*X_track(:,k_birth(i):1:k_death(i),i);
    figure(1); plot(k_birth(i):1:k_death(i),P(1,:),'-b'); hold on;
    figure(2); plot(k_birth(i):1:k_death(i),P(2,:),'-b'); hold on;
end;
%--- plot PHDs
for k=1:K
    if ~isempty(hat_X{k})
        P= model.C_posn*hat_X{k};
        figure(1); plot(k,P(1,:),'r.'); 
        figure(2); plot(k,P(2,:),'r.');
    end;
end;
figure(1); xlabel('time step','fontsize',15); ylabel('x','fontsize',15);
set(gca, 'XLim',[1 K]); set(gca, 'YLim',[0 room_dim(1)]);
figure(2); xlabel('time step','fontsize',15); ylabel('y','fontsize',15);
set(gca, 'XLim',[1 K]); set(gca, 'YLim',[0 room_dim(2)]);


%--- plot no. of targets
figure(3);
plot(1:K,N_true); hold on;
plot(1:K,round(hat_N),'--r');
set(gca, 'XLim',[1 K]); set(gca, 'YLim',[0 2]);