%--- coordinate plot with respect to time
% you need to define model.C_posn in order to work properly
file= 'nice1_2';

load([ '1filter_',file,'.mat']);

[X_track,k_birth,k_death]= extract_tracks(X,track_list,total_tracks);


figure(1); clf; subplot(211);
figure(2); clf; subplot(211);
figure(3); clf;

%--- plot true tracks
for i=1:total_tracks
    P= model.C_posn*X_track(:,k_birth(i):1:k_death(i),i);
    figure(1); h1_t= plot(k_birth(i):1:k_death(i),P(1,:),'-b'); hold on;
    figure(2); h2_t= plot(k_birth(i):1:k_death(i),P(2,:),'-b'); hold on;
end;

%---- plot the existing single filter
%load 1filter_nice1.mat
%--- plot 1 filter
P= model.C_posn*hat_x;
figure(1); h1_1f= plot(1:K,P(1,:),':'); 
figure(2); h2_1f= plot(1:K,P(2,:),':');


%--- plot 2 filter
load([ '2filter_',file,'.mat']);

%load 2filter_nice1.mat
for k=1:K
    if ~isempty(hat_X{k})
        P= model.C_posn*hat_X{k};
        figure(1); h1_2f= plot(k,P(1,:),'r.','Markersize',12); 
        figure(2); h2_2f= plot(k,P(2,:),'r.','Markersize',12);
    end;
end;
figure(1); xlabel('time step','fontsize',15); ylabel('x (in m)','fontsize',15);
set(gca, 'XLim',[1 K]);
set(gca, 'YLim',[0 3]);

%legend('True (totally 2 speakers)','Single-speaker particle filter',....
%    'Multi-speaker RFS particle filter',4);
legend([ h1_t; h1_2f(1); h1_1f ],'True (2 speakers in total)','Multi-speaker RFS particle filter',...
    'Single-speaker particle filter', 4);
figure(2); xlabel('time step','fontsize',15); ylabel('y (in m)','fontsize',15);
set(gca, 'XLim',[1 K]);
set(gca, 'YLim',[0 3]);


%--- plot no. of targets
N_true= zeros(K,1);
for k=1:K
    N_true(k)= size(X{k},2);
end;
figure(3); subplot(211); 
plot(1:K,N_true); hold on;
plot(1:K,round(hat_N),'.r','Markersize',12); 
set(gca, 'XLim',[1 K]); set(gca, 'YLim',[0 3]);
xlabel('time step','fontsize',15); ylabel('No. of active speakers','fontsize',15);
legend('True','Multi-speaker RFS particle filter');


