% Position and Histogram plots for the PHD filter
% this function overrides the original one for better visualization for the
% TDOA problem.

%---
no_of_bins_posn= 51;

%--- adjust the range of the plots automatically
limit= model.posn_interval(1:2,:); limit2= [ limit(1,:) limit(2,:) ];
%max_r= -Inf;
%for k=1:K
%    if N_true(k)>0 & hat_N(k)>0,
%        temp= abs([ model.C_xy_posn*hat_X{k} model.C_xy_posn*X{k}]);
%        max_r= max([ max_r, max(max(temp)) ]);
%    end;
%end;
%limit= max_r*[ -1 1; -1 1 ]; limit2= max_r*[ -1 1 -1 1 ];

%---
[X_track,k_birth,k_death]= extract_tracks(X,track_list,total_tracks);
figure; 
for k=1:K
    clf;
    subplot(121); 
    for i=1:total_tracks    %plot the tracks
        if k>= k_birth(i) & k<=k_death(i),
            P= model.C_xy_posn*X_track(:,k_birth(i):min(k,k_death(i)),i);
            plot(P(1,:),P(2,:),'-b'); hold on;
            text(P(1,size(P,2)),P(2,size(P,2)),['   ',num2str(i)]);
        end;
    end;
    %plot the position at time k
    if ~isempty(X{k}), P= model.C_xy_posn*X{k}; plot(P(1,:),P(2,:),'bo'); hold on; end;
    if exist('hat_X'),
        if ~isempty(hat_X{k}), P= model.C_xy_posn*hat_X{k}; plot(P(1,:),P(2,:),'r*'); end;
    end;
    title(['time= ',num2str(k),', true N= ',num2str(N_true(k))],'fontsize',15);
    xlabel('x','fontsize',15); ylabel('y','fontsize',15);
    axis(limit2); axis square;
    % histogram
    subplot(122);
    [bin2d,x,y]= hist2d(model.C_xy_posn*particle_X{k},[no_of_bins_posn; no_of_bins_posn],limit);
    pcolor(x,y,full(bin2d')); shading interp;
    xlabel('x','fontsize',15); ylabel('y','fontsize',15);
    title(['hatN= ',num2str(hat_N(k))],'fontsize',15);
    axis square; 
    %plot the tracks, as well
    hold on;
    for i=1:total_tracks    
        if k>= k_birth(i) & k<=k_death(i),
            P= model.C_xy_posn*X_track(:,k_birth(i):min(k,k_death(i)),i);
            plot(P(1,:),P(2,:),'-c'); 
            text(P(1,size(P,2)),P(2,size(P,2)),['   ',num2str(i)], 'color', [ 1 1 1 ]);
        end;
    end;
    if ~isempty(X{k}), P= model.C_xy_posn*X{k}; plot(P(1,:),P(2,:),'oc'); hold on; end;
    pause
end;