% Position and Histogram plots for the PHD filter
% this function overrides the original one for better visualization for the
% TDOA problem.

%--- adjust the range of the plots automatically
limit= model.posn_interval(1:2,:); limit2= [ limit(1,:) limit(2,:) ];


%---
[X_track,k_birth,k_death]= extract_tracks(X,track_list,total_tracks);
for k=1:K
    figure(1); clf;
    for i=1:total_tracks    %plot the tracks
        if k>= k_birth(i) & k<=k_death(i),
            P= model.C_xy_posn*X_track(:,k_birth(i):min(k,k_death(i)),i);
            plot(P(1,:),P(2,:),'-b'); hold on;
            text(P(1,size(P,2)),P(2,size(P,2)),['   ',num2str(i)]);
        end;
    end;
    %plot the position at time k
    if ~isempty(X{k}), P= model.C_xy_posn*X{k}; plot(P(1,:),P(2,:),'bo'); hold on; end;
    if exist('hat_x'),
        if ~isempty(hat_x(:,k)), P= model.C_xy_posn*hat_x(:,k); plot(P(1,:),P(2,:),'r*'); end;
    end;
    title(['time= ',num2str(k),', hat N= ',num2str(hat_N(k))],'fontsize',15);
    xlabel('x','fontsize',15); ylabel('y','fontsize',15);
    axis(limit2); axis square;
    pause
end;