%==== Multi-sensor 1 target Bayesian filtering:
% run this routine after you call 'declare_problem_single' and signal generation


%---
hat_N= zeros(K,1);      %(soft) estimate of the number of targets
hat_x= zeros(x_dim,K);
particle_X= cell(K,1);  %cell for storing all particles
particle_W= cell(K,1);  %cell for storing the update weights
Xk= [];
Wk= ones(Ns,1)/Ns;

for k=1:K
    time_start= cputime;
    %--- particle generation & multisensor weight update
    Xk_old= Xk;
    no_notempty_Xk= size(Xk_old,2);
    Wk_old_notempty= Wk(1:no_notempty_Xk);
    Wk_old_empty= Wk((no_notempty_Xk+1):Ns);
    Xk= []; Wk= [];
    %death process
    rv= rand(no_notempty_Xk,1);
    idx= find(rv <= P_death); idx_c= find(rv > P_death);
    Xk= gen_newstate(model,Xk_old(:,idx_c)); Wk= Wk_old_notempty(idx_c);
    %birth
    rv= rand((Ns-no_notempty_Xk),1);
    idx2= find( rv<= P_birth ); idx2_c= find( rv > P_birth );
    Xk= [ Xk gen_birthstate(model,length(idx2)) ];
    Wk= [ Wk; Wk_old_empty(idx2) ];
    %arrange weights of empty X to the end
    Wk= [ Wk; Wk_old_notempty(idx); Wk_old_empty(idx2_c) ];
    %--- weight update
    no_notempty_Xk= size(Xk,2);
    for q=1:Q
        Zk_len= size(Z{q,k},2);
        f_zx= zeros(1,no_notempty_Xk);
        for i=1:Zk_len
            f_zx= f_zx+ compute_likelihood(model,Z{q,k}(:,i),Xk,q);
        end;
        Wk(1:no_notempty_Xk)= Wk(1:no_notempty_Xk).* ...
            ( (1-P_D) + P_D*f_zx'/(lambda_c/prod(range_c(:,2)-range_c(:,1))) );
    end;
    %--- weight normalization and resampling
    Wk= Wk/sum(Wk);
    idx= resample(Wk,Ns);
    i1= find(idx<= no_notempty_Xk); i2= find(idx> no_notempty_Xk);
    idx_notempty= idx(i1); %idx_empty= idx(i2);
    Xk= Xk(:,idx_notempty);
    %Wk= [ Wk(idx_notempty); Wk(idx_empty) ];
    Wk= ones(Ns,1)/Ns;
    %--- estimate from particles
    hat_N(k)= no_notempty_Xk/Ns;
    hat_x(:,k)= sum(Xk')'/size(Xk,2);
    particle_X{k}= Xk; particle_W{k}= Wk;
end;

hat_X= cell(K,1);
for k=1:K
    hat_X{k}= hat_x(:,k);
end;

return
    


