%---
head_test1

%--- signal generation
y= zeros(N,2,P);    %received signal
ys= zeros(N,2,P);   %received signal without noise
for p=1:P
    for el=1:L
        s_seg= s( max([ 1 ((el-1)*Nframe-h_len+1) ]):(el*Nframe) );
        if length(s_seg)~=h_len,
            s_seg= [ zeros(h_len+Nframe-length(s_seg),1); s_seg ];
        end;
        yt= fftfilt(h(:,1,p,el),s_seg);
        yt= yt( (h_len+1):(Nframe+h_len) );
        ys((1+(el-1)*Nframe):(el*Nframe),1,p)= yt;
        yt= fftfilt(h(:,2,p,el),s_seg);
        yt= yt( (h_len+1):(Nframe+h_len) );
        ys((1+(el-1)*Nframe):(el*Nframe),2,p)= yt;
    end;
end;
        
ys_pow= sum(sum(sum(abs(ys).^2)))/(N*2*P);
y= ys+ randn(N,2,P)*sqrt(ys_pow/snr);

%--- xcorrelation computation
Sy1y2= cell(P,1);   %short-time cross spectral density between two microphones
for p=1:P
    Sy1y2{p}= st_xsd(y(:,1,p),y(:,2,p),Nframe,block_overlap);
end;
L= size(Sy1y2{1},2);   %no. of short-time frames

%generate a time interpolated DFT, partial on the TDOA range of interest
pts_per_sample= 8;
n_pts= -max_d:(1/pts_per_sample):max_d;
pDFT= zeros(length(n_pts),Nframe);  
for n=1:length(n_pts)
    temp= exp( -i*2*pi*(0:1:(Nframe/2))*n_pts(n)/Nframe );
    pDFT(n,:)= [ temp fliplr(conj(temp(2:(Nframe/2)))) ];
    %pDFT(n,:)= exp( i*2*pi*(0:1:(Nframe-1))*n_pts(n)/Nframe );
end;

cc= zeros(length(n_pts),L,P);     %cross correlation functions
for l=1:L
    for p=1:P
        Sy1y2{p}(:,l)= Sy1y2{p}(:,l)./abs(Sy1y2{p}(:,l));    %uncommenting this line leads to PHAT
        cc(:,l,p)= real(pDFT*Sy1y2{p}(:,l));
        %uncommenting the following line leads to normalization
        %cc(:,l,p)= cc(:,l,p)/norm(cc(:,l,p));
    end;
end;

%--- peak picking
max_peaks= 4;
len_n_pts= length(n_pts);
tdoa_peaks= cell(L,P);
%peak_pt_indices= cell(L,P);
for l=1:L
    for p=1:P
        cc_temp= cc(:,l,p);
        diff1_cc= cc_temp(2:(len_n_pts-1))- cc_temp(1:(len_n_pts-2));
        diff2_cc= cc_temp(2:(len_n_pts-1))- cc_temp(3:len_n_pts);
        idx= find( diff1_cc>0 & diff2_cc>0 );
        idx= idx+1;
        if length(idx) <= max_peaks
            tdoa_peaks{l,p}= n_pts(idx);
            %peak_pt_indices{l,p}= idx;
        else
            [notused,idx2]= sort(-cc_temp(idx));
            tdoa_peaks{l,p}= n_pts(idx(idx2(1:max_peaks)));
            %peak_pt_indices{l,p}= idx(idx2(1:max_peaks));
        end;
    end;
end;

%--- compute true TDOAs
true_tdoa= zeros(L,P);
for p=1:P
    for el=1:L
        true_tdoa(el,p)= (norm( x_s(:,el)- x_sensor(:,2,p) )- norm( x_s(:,el)- x_sensor(:,1,p) ))/dR;
    end;
end;

%--- plot the cross correlation functions for visualization
figure(1); clf;
plot(s);

for p=1:P
    figure(p+1); clf;
    pcolor(1:L,n_pts,cc(:,:,p));
    hold on;
    plot(1:L,true_tdoa(:,p),'w','linewidth',2);
    for el=1:L
        plot(el,tdoa_peaks{el,p},'or');
        plot(el,tdoa_peaks{el,p}(1),'*r');
    end;
end;