sigma= .3;
Ns= 30;
c= 1;

x= -4:0.01:4;
f= exp(-(x.^2)/(2*sigma^2))/(sqrt(2*pi)*sigma);

x_grid= -4:8/Ns:4;
f_grid= exp(-(x_grid.^2)/(2*sigma^2))/(sqrt(2*pi)*sigma);

x_imp= sigma*randn(Ns,1);
f_imp= c*ones(Ns,1);

figure(1); clf; subplot(211);
plot(x,f);
hold on;
stem(x_grid,f_grid,'r');
sx(x(1),x(length(x))); 
xlabel('x','FontSize',14); ylabel('f(x)','FontSize',14);

figure(2); clf; subplot(211);
plot(x,f);
hold on;
stem(x_imp,f_imp,'r');
sx(x(1),x(length(x))); 
xlabel('x','FontSize',14); ylabel('f(x)','FontSize',14);
